/*************************************************************************************************\
Author:         Jakub Schon
Company:        Husky Energy
Description:    Unit Test for VTT_WOA_SearchCriteria
History:        jschn 28/10/2019 - Created.
*************************************************************************************************/
@IsTest(IsParallel = true)
private class VTT_WOA_SearchCriteriaTest {

    @IsTest
    static void getActivitySort() {
        String result;

        Test.startTest();
        result = new VTT_WOA_SearchCriteria().getActivitySort();
        Test.stopTest();

        System.assertEquals(VTT_Utilities.WOA_SORT_ORDER, result, 'Sort Order for WOA records should be always ' + VTT_Utilities.WOA_SORT_ORDER);
    }

    @IsTest
    static void buildOuterWhereClause() {
        String result;

        Test.startTest();
        result = new VTT_WOA_SearchCriteria().buildOuterWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('RecordType.DeveloperName'), 'DeveloperName condition should be always present.');
    }

    @IsTest
    static void buildInnerWhereClause_emptyFilters() {
        String result;
        Boolean validWhereClause;

        Test.startTest();
        result = new VTT_WOA_SearchCriteria().buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
//        System.assert(!result.contains(' Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c'), 'As AMU filter is not set, "Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c" should not be part of the WHERE Clause'); NOTE: always part of WHERE Clause as it is part of VTT_Utilities.ACTIVITIES_TO_BE_SHOWN
//        System.assert(!result.contains(' Name'), 'As any text filter is not set, "Name" should not be part of the WHERE Clause'); NOTE: always part of WHERE Clause as it is part of VTT_Utilities.ACTIVITIES_TO_BE_SHOWN
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_plannerGroup() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.plannerGroupFilter = 'Test1';

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is set, "Maintenance_Work_Order__r.Planner_Group__c" should be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_vendor() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.vendorFilter = UserInfo.getUserId();

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(result.contains(' Assigned_Vendor__c'), 'As Vendor filter is set, "Assigned_Vendor__c" should be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_vendorAny() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.vendorFilter = '1';

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(result.contains('Assigned_Vendor__c'), 'As Vendor filter is set, "Assigned_Vendor__c" should be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_anyTradesmen() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.tradesmanFilter = '1';

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is set to any, "Number_of_assigned_people__c" should be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_tradesmen() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.tradesmanFilter = 'Test1';

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(result.contains(' Id'), 'As Tradesman filter is set, "Id" should be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_multiStatus() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.activityMultiStatusFilter = new List<String>{'Test1'};

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(result.contains(' Status__c IN'), 'As Multi Status filter is set, "Status__c" should be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_route() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.routeFilter = 'Test1';

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is set, "Maintenance_Work_Order__r.Plant_Section__c" should be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_AMU() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.amuFilter = UserInfo.getUserId();

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        System.assert(result.contains(' Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c'), 'As AMU filter is set, "Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c" should be part of the WHERE Clause'); //NOTE: always part of WHERE Clause as it is part of VTT_Utilities.ACTIVITIES_TO_BE_SHOWN
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_scheduledFrom() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.scheduledFromFilter = Date.newInstance(1991, 10, 8);

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_scheduledTo() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.scheduledToFilter = Date.newInstance(1991, 10, 8);

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_hideCompleted() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.hideCompletedFilter = true;

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should be part of the WHERE Clause');
        System.assert(result.contains(VTT_Utilities.ACTIVITY_STATUS_COMPLETED), 'As Hide Completed filter is set, "' + VTT_Utilities.ACTIVITY_STATUS_COMPLETED + '" should be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_anyFilter() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.filterName = 'Test1';

        Test.startTest();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Id'), 'As Tradesman filter is not set, "Id" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(result.contains('Assigned_Text__c'), 'As any text filter is set, "Assigned_Text__c" should be part of the WHERE Clause');
        System.assert(result.contains('Functional_Location_Description_SAP__c'), 'As any text filter is set, "Functional_Location_Description_SAP__c" should be part of the WHERE Clause');
        System.assert(result.contains('Maintenance_Work_Order__r.Name'), 'As any text filter is set, "Maintenance_Work_Order__r.Name" should be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    @IsTest
    static void buildInnerWhereClause_tradesmenMock() {
        String result;
        Boolean validWhereClause;
        VTT_WOA_SearchCriteria searchCriteria = new VTT_WOA_SearchCriteria();
        searchCriteria.tradesmanFilter = 'Test1';

        Test.startTest();
        VTT_WOA_SearchCriteria.assignmentSelector = new AssignmentMockSingleRecord();
        result = searchCriteria.buildInnerWhereClause();
        Test.stopTest();

        System.assert(String.isNotBlank(result), 'Should always provide result.');
        System.assert(result.contains('WHERE'), 'WHERE clause should always contain WHERE');
        System.assert(result.contains('SAP_Deleted__c = false'), 'Base query should always contain "SAP_Deleted__c = false"');
        System.assert(result.contains('Status__c'), 'Base query should always contain "Status__c"');
        System.assert(result.contains(VTT_Utilities.ACTIVITIES_TO_BE_SHOWN), 'Base query should always contain ' + VTT_Utilities.ACTIVITIES_TO_BE_SHOWN);
        System.assert(!result.contains(' Maintenance_Work_Order__r.Planner_Group__c'), 'As Planner Group filter is not set, "Maintenance_Work_Order__r.Planner_Group__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Vendor__c'), 'As Vendor filter is not set, "Assigned_Vendor__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Number_of_assigned_people__c'), 'As Tradesman filter is not set to any, "Number_of_assigned_people__c" should not be part of the WHERE Clause');
        System.assert(result.contains(' Id'), 'As Tradesman filter is set, "Id" should be part of the WHERE Clause');
        System.assert(!result.contains(' Status__c IN'), 'As Multi Status filter is not set, "Status__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Plant_Section__c'), 'As Route filter is not set, "Maintenance_Work_Order__r.Plant_Section__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Assigned_Text__c'), 'As any text filter is not set, "Assigned_Text__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Functional_Location_Description_SAP__c'), 'As any text filter is not set, "Functional_Location_Description_SAP__c" should not be part of the WHERE Clause');
        System.assert(!result.contains(' Maintenance_Work_Order__r.Name'), 'As any text filter is not set, "Maintenance_Work_Order__r.Name" should not be part of the WHERE Clause');
        System.assert(!result.contains(' DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))'), 'As date filter is not set, "DAY_ONLY(convertTimezone(Scheduled_Start_Date__c))" should not be part of the WHERE Clause');
        try {
            Database.query('SELECT Id FROM Work_Order_Activity__c ' + result);
            validWhereClause = true;
        } catch (Exception ex) {
            validWhereClause = false;
        }
        System.assert(validWhereClause);
    }

    public class AssignmentMockSingleRecord implements VTT_WOA_AssignmentDAO {
        public List<Work_Order_Activity_Assignment__c> getNonRejectedAssignmentsByTradesman(String tradesman) {
            return new List<Work_Order_Activity_Assignment__c>{
                    new Work_Order_Activity_Assignment__c()
            };
        }
        public List<Work_Order_Activity_Assignment__c> getNonRejectedAssignmentsByActivity(Id activityId) {return null;}
        public List<Work_Order_Activity_Assignment__c> getAssignments(Set<Id> activityIdsForDeletion) {return null;}
        public List<Work_Order_Activity_Assignment__c> getAssignments(Set<Id> activityIdsForDeletion, List<Work_Order_Activity__c> activities, List<Id> tradesmenIds) {return null;}
        public List<Work_Order_Activity_Assignment__c> getAssignments(List<Work_Order_Activity__c> activities, List<Id> tradesmenIds) {return null;}
    }

}